function [penalized_f]=lower_penalized(objective_function,constraints,penalty_factor2)
trials=length(objective_function);
for i=1:trials
    penalized_f(i)=0;
    if all(constraints(:,i)<0)==1
        penalized_f(i)=objective_function(i);
    else
        violated_constraints=find(constraints(:,i)>0);
        penalty_factor=1;
        for j=1:length(violated_constraints)        
            penalty_factor=penalty_factor + penalty_factor2*constraints(violated_constraints(j),i);
        end
        penalized_f(i)=objective_function(i)*penalty_factor;
    end
end



