function [population,target_f,constraint,particle_counter,history_best_f,...
    best_individual,history_f,best_current_individual,history_g]=...
    new_population(fun,entire_population,counting_number,feasibles_initial_population,Feasible_Set,penalty_factor,...
    counter_number,LowerB,UpperB)

feasible_solutions=0;
infeasible_solutions=0;

feasibles=[];
current_objective_function=[];
current_constraints=[];

infeasible_current_solution=[];
infeasible_objective_function=[];
infeasible_constraints=[];

counter=1;

best_f=inf;
best_current_f=inf;

particle_counter=0;

if feasibles_initial_population==-1
    for i=1:entire_population
        for j=1:counter_number
            population(j,i) = LowerB(j) + (UpperB(j)-LowerB(j))*rand;            
        end
        for j=counter_number+1:counting_number
            profile_number=length(find(Feasible_Set(j-counter_number,:)~=inf));
            profile=Feasible_Set(j-counter_number,(1:profile_number));
            population(j,i)=item_value(profile);
        end
    end
    for i=1:entire_population
        [f,g]=feval(fun,population(:,i));
        particle_counter=particle_counter+1;
        if all(g<0)==1
            feasible_solutions=feasible_solutions+1;
            feasibles(:,feasible_solutions)=population(:,i);
            current_objective_function(feasible_solutions)=f;
            current_constraints(:,feasible_solutions)=g;
        else        
            infeasible_solutions=infeasible_solutions+1;
            infeasible_current_solution(:,infeasible_solutions)=population(:,i);
            infeasible_objective_function(infeasible_solutions)=f;
            infeasible_constraints(:,infeasible_solutions)=g;
        end
    end
else
    while feasible_solutions < feasibles_initial_population
        population=[];
        for i=1:entire_population
            for j=1:counter_number
                population(j,i) = LowerB(j) + (UpperB(j)-LowerB(j))*rand;            
            end
            for j=counter_number+1:counting_number
                profile_number=length(find(Feasible_Set(j-counter_number,:)~=inf));
                profile=Feasible_Set(j-counter_number,(1:profile_number));
                population(j,i)=item_value(profile);
            end
        end
        for i=1:entire_population
            [f,g]=feval(fun,population(:,i));
            particle_counter=particle_counter+1;
            if all(g<0)==1
                feasible_solutions=feasible_solutions+1;
                feasibles(:,feasible_solutions)=population(:,i);
                current_objective_function(feasible_solutions)=f;
                current_constraints(:,feasible_solutions)=g;
                disp(' ');
                disp('Amount of feasible solutions:')
                feasible_solutions
                 if feasible_solutions==feasibles_initial_population
                    break;
                end
            elseif infeasible_solutions<entire_population
                infeasible_solutions=infeasible_solutions+1;
                infeasible_current_solution(:,infeasible_solutions)=population(:,i);
                infeasible_objective_function(infeasible_solutions)=f;
                infeasible_constraints(:,infeasible_solutions)=g;

            end
        end
        counter=counter+1;
    end
   if infeasible_solutions < (entire_population-feasibles_initial_population)
        while infeasible_solutions < (entire_population-feasibles_initial_population)
            for j=1:counter_number
                uusi_individual(1,j) = LowerB(j) + (UpperB(j)-LowerB(j))*rand;            
            end
            for j=counter_number+1:counting_number
                profile_number=length(find(Feasible_Set(j-counter_number,:)~=inf));
                profile=Feasible_Set(j-counter_number,(1:profile_number));
                uusi_individual(1,j)=item_value(profile);
            end
            [f,g]=feval(fun,uusi_individual);
            particle_counter=particle_counter+1;
            if all(g<0)==0
                infeasible_solutions=infeasible_solutions+1;
                infeasible_current_solution(:,infeasible_solutions)=uusi_individual';
                infeasible_objective_function(infeasible_solutions)=f;
                infeasible_constraints(:,infeasible_solutions)=g;
            end
        end
    end
end
population=infeasible_current_solution;
objective_function=infeasible_objective_function;
constraints=infeasible_constraints;
for i=(entire_population-feasible_solutions):entire_population-1
    population(:,i+1)=feasibles(:,i-(entire_population-feasible_solutions)+1);
    objective_function(i+1)=current_objective_function(i-(entire_population-feasible_solutions)+1);
    constraints(:,i+1)=current_constraints(:,i-(entire_population-feasible_solutions)+1);
end
penalized_f=lower_penalized(objective_function,constraints,penalty_factor);
target_f=penalized_f;
constraint=constraints;
if length(current_objective_function)~=0
    [history_f,index]=min(current_objective_function);
    index=index+(entire_population-feasible_solutions);
    history_g(:,1)=constraints(:,index);
    best_current_individual=population(:,index);
else
    history_f=inf;
    history_g=[];
    best_current_individual=[];
end
[history_best_f,index]=min(penalized_f);
best_individual=population(:,index);

