function [population,objective_function,constraint,particle_counter,best_f,best_x,...
    best_current_f,best_current_x,best_current_g] = lue_popu(fun,tiedosto,...
    particle_counter,swarm_size,counter_number,feasibles_initial_population,...
    Feasible_Set,penalty_factor);    

pid=fopen(tiedosto);
if pid==-1
    error(' ');
end
i=1;
while 1
   line=fgetl(pid);
   if isempty(line)==1 | line==-1, break, end
   read_alternative(i,:)=str2num(line);
   i=i+1;
end
population=read_alternative';
fclose(pid); 
if length(population(1,:))<swarm_size
    error(' ');
end
if length(population(1,:))>swarm_size
    error(' ');
end
if length(population(:,1))<counter_number
    error(' ');
end
if length(population(:,1))>counter_number
    error(' ');
end
feasible_solutions=0;
infeasible_solutions=0;
best_f=inf;
best_current_f=inf;
for i=1:swarm_size
    [f,g]=feval(fun,population(:,i));
    particle_counter=particle_counter+1;
    if all(g<0)==1
        feasible_solutions=feasible_solutions+1;
        current_objective_function(feasible_solutions)=f;
        current_x(:,feasible_solutions)=population(:,i);
        current_g(:,feasible_solutions)=g;
    end
    objective_function(i)=f;
    constraint(:,i)=g;
end
if feasible_solutions<feasibles_initial_population & feasibles_initial_population~=-1
    error(' ')
end
if feasible_solutions>feasibles_initial_population & feasibles_initial_population~=-1
    error(' ')
end
if feasible_solutions~=feasibles_initial_population & feasibles_initial_population~=-1
    error(' ')
end



penalized_f=lower_penalized(objective_function,constraint,penalty_factor);
[best_current_f,index]=min(current_objective_function);
best_current_x=current_x(:,index);
best_current_g=current_g(:,index);
[best_f,index]=min(penalized_f);
best_x=population(:,index);



