clear
clc

open('Objective_function_per_iteretion_ARC4.fig');
D=get(gca,'Children'); %get the handle of the line object
XData=get(D,'XData'); %get the x data
YData=get(D,'YData'); %get the y data
ARC4=[XData' YData']; %join the x and y data on one array nx2

open('Objective_function_per_iteretion_ARC5.fig');
D=get(gca,'Children'); %get the handle of the line object
XData=get(D,'XData'); %get the x data
YData=get(D,'YData'); %get the y data
ARC5=[XData' YData']; %join the x and y data on one array nx2

open('Objective_function_per_iteretion_ARC6.fig');
D=get(gca,'Children'); %get the handle of the line object
XData=get(D,'XData'); %get the x data
YData=get(D,'YData'); %get^ the y data
ARC6=[XData' YData']; %join the x and y data on one array nx2

open('Objective_function_per_iteretion_ARC7.fig');
D=get(gca,'Children'); %get the handle of the line object
XData=get(D,'XData'); %get the x data
YData=get(D,'YData'); %get the y data
ARC7=[XData' YData']; %join the x and y data on one array nx2


figure
plot(ARC4{1},ARC4{3})                   %/8.3744*10^4
%plot(ARC4{2},ARC4{4})
xlabel('Number of iterations');       %  add axis labels and plot title
ylabel('Objective function [kg/m]');
title('Arctic Class Weight Comparison');
whitebg('white')
hold on
grid minor
plot(ARC5{1},ARC5{3},'g')               %/8.590500*10^4
%plot(ARC5{2},ARC5{4},'g')
plot(ARC6{1},ARC6{3},'red')             %/9.4376*10^4
%plot(ARC6{2},ARC6{4},'red')
plot(ARC7{1},ARC7{3},'black')           %/1.0045*10^5
%plot(ARC7{2},ARC7{4},'c')
legend('Best feasible (ARC4)','Best feasible (ARC5)','Best feasible (ARC6)','Best feasible (ARC7)');
