function [check_RR] = Russian_rules_func(Isklasse,B,L,Strakes,Csec_size,Delta,ey_stiff_eff);


if B <= 20 %[m]
    h1 = [0.5 0.5 0.5 0.60 0.75 0.75 0.75 0.75 0.75]; %[m]       
else
    h1 = [0.5 (0.5*B+8)/36 (0.5*B+8)/36 (0.5*B+8)/30 (0.5*B+8)/24 (0.5*B+8)/24 (0.5*B+8)/24 (0.5*B+8)/24 (0.5*B+8)/24]; %[m]
end

h2 = [0.2 0.2 0.2 0.6 0.8 0.8 1.4 1.4 1.4]; %[m]
h3 = [1 1 1.1 1.2 1.35 1.35 1.6 1.6 1.6].*h1; %[m]
L2 = L*[0 0.02 0.02 0.05 0.1 0.1 0.15 0.15 0.15]; %[m]
L3 = L*[0.02 0.02 0.04 0.045 0.05 0.05 0.06 0.06 0.06]; %[m]
k1 = [0 0.5 0.53 0.55 0.69 0.69 0.84 0.84 0.84]; %[m]
a3 = [0 0.22 0.33 0.5 0.78 1.2 1.84 3.7 5.6]; %[-]
aB2 = [0 0 0 0.4 0.5 0.5 0.5 0.55 0.55];
aB3 = [0 0 0 0 0.4 0.45 0.45 0.45 0.45];
aB4 = [0 0 0 0 0 0 0 0.25 0.3];
C3 = [0 0.27 0.3 0.34 0.4 0.47 0.5 0.5 0.5];
u = [0.21 0.21 0.21 0.26 0.28 0.3 0.3 0.3 0.3];
k1_plate = [1.3 1.3 1.3 1.3 1.3 1.2 1.1 1 1];

if Isklasse == 1
    h1 = h1(1,1); 
    h2 = h2(1,1);
    h3 = h3(1,1);
    L2 = L2(1,1);
    L3 = L3(1,1);
    k1 = k1(1,1);
    a3 = a3(1,1);
    aB2 = aB2(1,1);
    aB3 = aB3(1,1);
    aB3 = aB3(1,1);
    C3 = C3(1,1);
    u = u(1,1);
    k1_plate = k1_plate(1,1);
    Sl = Sl(1,1);
    Sb = Sb(1,1);
elseif Isklasse == 2
    h1 = h1(1,2);
    h2 = h2(1,2);
    h3 = h3(1,2);
    L2 = L2(1,2);
    L3 = L3(1,2);
    k1 = k1(1,2);
    a3 = a3(1,2);
    aB2 = aB2(1,2);
    aB3 = aB3(1,2);
    aB4 = aB4(1,2);
    C3 = C3(1,2);
    u = u(1,2);
    k1_plate = k1_plate(1,2);
    Sl = Sl(1,2);
    Sb = Sb(1,2);
elseif Isklasse == 3
    h1 = h1(1,3);
    h2 = h2(1,3);
    h3 = h3(1,3);
    L2 = L2(1,3);
    L3 = L3(1,3);
    k1 = k1(1,3);
    a3 = a3(1,3);
    aB2 = aB2(1,3);
    aB3 = aB3(1,3);
    aB4 = aB4(1,3);
    C3 = C3(1,3);
    u = u(1,3);
    k1_plate = k1_plate(1,3);
    Sl = Sl(1,3);
    Sb = Sb(1,3);
elseif Isklasse == 4
    h1 = h1(1,4) ; 
    h2 = h2(1,4);
    h3 = h3(1,4);
    L2 = L2(1,4);
    L3 = L3(1,4);
    k1 = k1(1,4);
    a3 = a3(1,4);
    aB2 = aB2(1,4);
    aB3 = aB3(1,4);
    aB4 = aB4(1,4);
    C3 = C3(1,4);
    u = u(1,4);
    k1_plate = k1_plate(1,4);
    Sl = Sl(1,4);
    Sb = Sb(1,4);
elseif  Isklasse == 5
    h1 = h1(1,5);
    h2 = h2(1,5);
    h3 = h3(1,5);
    L2 = L2(1,5);
    L3 = L3(1,5);
    k1 = k1(1,5);
    a3 = a3(1,5);
    aB2 = aB2(1,5);
    aB3 = aB3(1,5);
    aB4 = aB4(1,5);
    C3 = C3(1,5);
    u = u(1,5);
    k1_plate = k1_plate(1,5);
%     Sl = Sl(1,5);
%     Sb = Sb(1,5);
elseif   Isklasse == 6
    h1 = h1(1,6);
    h2 = h2(1,6);
    h3 = h3(1,6);
    L2 = L2(1,6);
    L3 = L3(1,6);
    k1 = k1(1,6);
    a3 = a3(1,6);
    aB2 = aB2(1,6);
    aB3 = aB3(1,6);
    aB4 = aB4(1,6);
    C3 = C3(1,6);
    u = u(1,6);
    k1_plate = k1_plate(1,6);
%     Sl = Sl(1,6);
%     Sb = Sb(1,6);
elseif   Isklasse == 7
    h1 = h1(1,7);
    h2 = h2(1,7);
    h3 = h3(1,7);
    L2 = L2(1,7);
    L3 = L3(1,7);
    k1 = k1(1,7);
    a3 = a3(1,7);
    aB2 = aB2(1,7);
    aB3 = aB3(1,7);
    aB4 = aB4(1,7);
    C3 = C3(1,7);
    u = u(1,7);
    k1_plate = k1_plate(1,7);
%     Sl = Sl(1,7);
%     Sb = Sb(1,7);
elseif   Isklasse == 8
    h1 = h1(1,8);
    h2 = h2(1,8);
    h3 = h3(1,8);
    L2 = L2(1,8);
    L3 = L3(1,8);
    k1 = k1(1,8);
    a3 = a3(1,8);
    aB2 = aB2(1,8);
    aB3 = aB3(1,8);
    aB4 = aB4(1,8);
    C3 = C3(1,8);
    u = u(1,8);
    k1_plate = k1_plate(1,8);
%     Sl = Sl(1,8);
%     Sb = Sb(1,8);
elseif   Isklasse == 9
    h1 = h1(1,9);
    h2 = h2(1,9);
    h3 = h3(1,9);
    L2 = L2(1,9);
    L3 = L3(1,9);
    k1 = k1(1,9);
    a3 = a3(1,9);
    aB2 = aB2(1,9);
    aB3 = aB3(1,9);
    aB4 = aB4(1,9);
    C3 = C3(1,9);
    u = u(1,9);
    k1_plate = k1_plate(1,9);
%     Sl = Sl(1,9);
%     Sb = Sb(1,9);
end



%MAXIMUM SPACING OF STIFFENERS (Longitudinally stiffened)%

if Isklasse == 9 || Isklasse == 8 || Isklasse == 7 || Isklasse == 6
    for i=1:Csec_size/2
        if Strakes(1,1,i) == 9 || Strakes(1,1,i) == 8 || Strakes(1,1,i) == 2 || Strakes(1,1,i) == 1
            s(i,1) = 0.6; %[m]
        end
    end
end
if Isklasse == 9 || Isklasse == 8 || Isklasse == 7 || Isklasse == 6 || Isklasse == 5 %Isklasse 5, gjelder for region I
    for i=1:Csec_size/2
        if Strakes(1,1,i) == 9
            s(i,1) = 0.6; %[m]
        end
    end
end

if Isklasse == 5
    for i=1:Csec_size/2
        if Strakes(1,1,i) == 8 || Strakes(1,1,i) == 2 || Strakes(1,1,i) == 1
            s(i,1) = 0.8; %[m]
        end
    end
end

if Isklasse == 4
    for i=1:Csec_size/2
        if Strakes(1,1,i) == 9 || Strakes(1,1,i) == 8 || Strakes(1,1,i) == 2 || Strakes(1,1,i) == 1
            s(i,1) = 0.8; %[m]
        end
    end
end



%ICE PRESSURE%

%Ice pressure region I, for midship - B%
for i=1:Csec_size/2
    if Strakes(1,1,i) == 9
        pBI = 1200*a3*nthroot(Delta/1000,6); %[m]
    end
end

for i=1:Csec_size/2
    if Strakes(1,1,i) == 9 || Strakes(1,1,i) == 13
        pB(i,1) = pBI; %[m]
    end
end

%Ice pressure region II, for midship - B%
for i=1:Csec_size/2
    if Strakes(1,1,i) == 8 || Strakes(1,1,i) == 7
        pB(i,1) = aB2*pBI; %[m]
    end
end

%Ice pressure region III, for midship - B%
for i=1:Csec_size/2
    if Strakes(1,1,i) == 2
        pB(i,1) = aB3*pBI; %[m]
    end
end

%Ice pressure region IV, for midship - B %
for i=1:Csec_size/2
    if Strakes(1,1,i) == 1 || Strakes(1,1,i) == 4 ||Strakes(1,1,i) == 5
        pB(i,1) = aB4*pBI; %[m]
    end
end




%VERTICAL DISTRIBUTION OF ICE PRESSURE%

k_delta = nthroot(Delta/1000,3);

if k_delta > 3.5
    k_delta = 3.5;
end

C4 = 1; %Only required to have a slope at Arc 8 and 9

%Vertical distribution of ice pressure, for midship - B%
for i=1:Csec_size/2
    if Strakes(1,1,i) == 9 ||Strakes(1,1,i) == 8 || Strakes(1,1,i) == 2 || Strakes(1,1,i) == 1 || Strakes(1,1,i) == 4 ||Strakes(1,1,i) == 5 || Strakes(1,1,i) == 13 ||Strakes(1,1,i) == 7
        bB(i,1) = C3*C4*k_delta; %[m]
    end
end


%HORISONTAL DISTRIBUTION OF ICE PRESSURE%

%Horisontal distribution of ice pressure, for midship - B%
for i=1:Csec_size/2
    if Strakes(1,1,i) == 9 ||Strakes(1,1,i) == 8 || Strakes(1,1,i) == 2 || Strakes(1,1,i) == 1
        lpB(i,1) = 6*bB(i,1); %[m]
        
        if lpB(i,1) < 3*sqrt(k_delta);
            lpB(i,1) = 3*sqrt(k_delta);
        end
    end
end


%SHELL PLATING THICKNESS (Longitudinally stiffened%

T = 20;                         %Planned ship life, in years
ReH = 235;                      %Upper yield stress [MPa]

Delta_Ssp0 = 0.75*T*u;

for i=1:Csec_size/2
    if Strakes(1,1,i) == 9 ||Strakes(1,1,i) == 8 || Strakes(1,1,i) == 2 || Strakes(1,1,i) == 1
        a0(i,1) = Strakes(1,4,i)./(1+0.5*(Strakes(1,4,i)./Strakes(1,20,i)));
        
        Ssp0(i,1) = 15.8*a0(i,1)*sqrt(pB(i,1)./ReH);
        
        Ssp(i,1) = Ssp0(i,1) + Delta_Ssp0;
    end
end

%Determening the actual value of the ultimate section modulus of girders%
for i=1:Csec_size/2
    if Strakes(1,1,i) == 9 ||Strakes(1,1,i) == 8 || Strakes(1,1,i) == 2 || Strakes(1,1,i) == 1
        bef(i,1) =  Strakes(1,4,i)*10^2;                                                        %Effective flange breadth in cm, to be adopted equal to:
                                                                                                %Conventional frame spacing for conventional and deep frames where transverse framing is used;
                                                                                                %Longitudinal spacing,for longitudinals where longitudinal framing is used;
                                                                                                %1/6 of deep frame span between decks or platforms, or of frame spacing, whichever is less,for deed frames where longitudinal framing is used;
                                                                                                %1/6 frame spaceing, for stringers where web framing is used; 
                                                                                                %Half the sum of spacings of two adjacent girders of the same direction or 1/6 of girder span, whichever is less, in all other cases.

        tfp(i,1) = 1.5*Strakes(1,13,i)*10;                                                      %Face plate thickness in mm

        tef(i,1) = Strakes(1,3,i)*10;                                                           %Effective flange thickness in mm

        fef(i,1) = 0.1*bef(i,1)*tef(i,1);                                                       %Effective flange area of shell plating in cm2

        fw(i,1) = 0.1*((Strakes(1,15,i)*10^-1)-0.05*(tfp(i,1)+tef(i,1)))*Strakes(1,13,i)*10;    %[cm2]

        fsec(i,1) = Strakes(1,9,i);                                                             %[cm2]

        if fef(i,1) >= fsec(i,1)
            C(i,1) = 0;
        elseif fef(i,1) < fsec(i,1)
            C(i,1) = ((fsec(i,1)-fef(i,1))^2)/(4*fw(i,1));
        end

        if fef(i,1) >= fsec(i,1)
            Wa(i,1) = fsec(i,1)*(ey_stiff_eff(i,1)+0.05*tef(i,1));                              %[cm3]
        else
            Wa(i,1) = (Strakes(1,15,i)*10^-1)*(fsec(i,1) - 0.5*fw(i,1) - C(i,1));               %[cm3]
        end
    end
end

%Determening the actual value of the web area of girders%
for i=1:Csec_size/2
    if Strakes(1,1,i) == 9 ||Strakes(1,1,i) == 8 || Strakes(1,1,i) == 2 || Strakes(1,1,i) == 1
        Aa(i,1) = (Strakes(1,3,i)+Strakes(1,11,i))*Strakes(1,13,i);                             %[cm2]
    end
end


%Side and bottom longitudinals as part of longitudinal framing%

for i=1:Csec_size/2
    if Strakes(1,1,i) == 9 ||Strakes(1,1,i) == 8 || Strakes(1,1,i) == 2 || Strakes(1,1,i) == 1
        b_avrg(i,1) = bB(i,1)./Strakes(1,4,i);

        k0(i,1) = 1-(0.3/b_avrg(i,1));

        if b_avrg(i,1) >= 2
            b2(i,1) = Strakes(1,4,i);
        else
            b2(i,1) = bB(i,1)*(1-0.25*b_avrg(i,1));
        end
    
        b1(i,1) = k0(i,1)*b2(i,1);

        c = 1;                                                                                  %c = 1, for bottom longitudinals and for side longitudinals where no panting frames are fitted

        Delta_s = u*(T-12);

        kl(i,1) = 0.8;

        if kl(i,1) > 1/(1+0.76*(a0(i,1)/Strakes(1,20,i)));
            kl(i,1) = 0.8;
        else
            kl(i,1) = 1/(1+0.76*(a0(i,1)/Strakes(1,20,i)));
        end
    
        %The web area requirement, in cm2, of a longitudinal%
        Al(i,1) = (8.7/ReH)*pB(i,1)*b1(i,1)*Strakes(1,20,i)*c*kl(i,1) + 0.1*(Strakes(1,14,i)*10^-1)*Delta_s;


        kc = 0.9;                                                                               %kc = 0.9 for rolled profiles and 0.85 for welded profiles  
        
        ks = 1;                                                                                 %ks = 1 for plate sections, ks = 0.8 in other cases

        omega_l(i,1) = 1+(kc*(Delta_s/(Strakes(1,13,i)*10)));                                   %omega_l = 1.15 for the purpose of simplified calculations in accordance with 3.10.4.2.4

        gamma_l(i,1) = Al(i,1)/Aa(i,1);
        
        if gamma_l(i,1) > 1
            gamma_l(i,1) = 1;
        end

        kl(i,1) = 1/(1+sqrt(1-ks*(gamma_l(i,1).^2)));

        Wl0(i,1) = (125/ReH)*pB(i,1)*b1(i,1)*Strakes(1,20,i)*(Strakes(1,20,i)-0.5*Strakes(1,4,i))*(c^2)*omega_l(i,1);

        %The ultimate section modulus requirements%
        Wl(i,1) = Wl0(i,1)*kl(i,1);                                                             %[cm3]
    end
end

%The web thickness requirements [mm]%
for i=1:Csec_size/2
    if Strakes(1,1,i) == 9 ||Strakes(1,1,i) == 8 || Strakes(1,1,i) == 2 || Strakes(1,1,i) == 1
        ks_area(i,1) = 1.4*(Wl(i,1)/Wa(i,1));

        if ks_area(i,1) < 1
            ks_area(i,1) = 1;
        end
        
        
        sl(i,1) = (ks_area(i,1)/ReH)*pB(i,1)*b1(i,1) + Delta_s;

        if sl(i,1) > (0.013*(Strakes(1,14,i)*10^-1)*sqrt(ReH)) + Delta_s;
            sl(i,1) = (ks_area(i,1)/ReH)*pB(i,1)*b1(i,1) + Delta_s;
        else
            
            sl(i,1) = (0.013*(Strakes(1,14,i)*10^-1)*sqrt(ReH)) + Delta_s;
        end
    end
end

%The face plate breadth requirements [mm]%
for i=1:Csec_size/2
    if Strakes(1,1,i) == 9 ||Strakes(1,1,i) == 8 || Strakes(1,1,i) == 2 || Strakes(1,1,i) == 1
        alpha(i,1) = (((Strakes(1,13,i)*10)/(Strakes(1,3,i)*10))^2)+((0.01*(Strakes(1,14,i)*10^-1)*(Strakes(1,3,i)*10))/(Strakes(1,4,i)*(Strakes(1,13,i)*10)));
        
        if alpha(i,1)<1
            alpha(i,1) = 1;
        end
        
        beta(i,1) = ((2-alpha(i,1))*Strakes(1,20,i))/(alpha(i,1)*(Strakes(1,14,i)*10^-1));
        
        if beta(i,1)<0.055
            beta(i,1) = 0.055;
        end
        
        
        cl(i,1) = 0.0145*ReH*(Wl(i,1)/Wa(i,1))*sqrt(tfp(i,1)*Strakes(1,13,i)*10)*((Strakes(1,14,i)*10^-1)/(Strakes(1,13,i)*10)-0.98);
        
        if cl(i,1)<2.5*tfp(i,1)
            cl(i,1) = 2.5*tfp(i,1);
        elseif cl(i,1) < 69.6*(Strakes(1,13,i)*10)*sqrt(((Strakes(1,14,i)*10^-1)/tfp(i,1))*(beta(i,1)^2-0.0029))
            cl(i,1) = 69.6*(Strakes(1,13,i)*10)*sqrt(((Strakes(1,14,i)*10^-1)/tfp(i,1))*(beta(i,1)^2-0.0029));
        end
    end
end

%The requirements intertia moment of stiffeners%
for i=1:Csec_size/2
    if Strakes(1,1,i) == 9 ||Strakes(1,1,i) == 8 || Strakes(1,1,i) == 2 || Strakes(1,1,i) == 1
        I(i,1) = 0.01*ReH*(Strakes(1,20,i)^2)*((10*Strakes(1,3,i)*10*Strakes(1,4,i))+Strakes(1,9,i));
    end
end

%The plate structure thickness of decks and platforms, as well as of double bottom stringers and centre girder%

for i=1:Csec_size/2
    if Strakes(1,1,i) == 4 ||Strakes(1,1,i) == 5 || Strakes(1,1,i) == 7 || Strakes(1,1,i) == 13
        Csp(i,1) = Strakes(1,4,i);                      %[m]
        
        Delta_s = u*(T-12);                             %[mm]
        
        kp = 1;
        
        kT = 0.17*(Delta^(1/6));
        
        if kT < 1
            kT = 1;
        end
        
        k2_plate = kT*sqrt(kp); 
        
        pBl(i,1) = k1_plate*pB(i,1);
        
        a0(i,1) = Strakes(1,4,i)./(1+0.5*(Strakes(1,4,i)./Strakes(1,20,i)));
        
        Ssp0(i,1) = 15.8*a0(i,1)*sqrt(pB(i,1)./ReH);
        
        Sps01(i,1) = bB(i,1)*(0.8*(pBl(i,1)/ReH)-0.0045*k2_plate*(1+4*((Csp(i,1)/(k2_plate*bB(i,1))^2)))*((Ssp0(i,1)/(10*Csp(i,1)))^3.5)); 
        
        Sps1(i,1) = Sps01(i,1) + Delta_s;               %[mm]
    end
end

%The plate thickness general requirement of decks and platforms, as well as of double bottom stringers and centre girder%
for i=1:Csec_size/2
    if Strakes(1,1,i) == 4 ||Strakes(1,1,i) == 5 || Strakes(1,1,i) == 7 || Strakes(1,1,i) == 13
        n1(i,1) = (1+((Strakes(1,4,i)/Strakes(1,20,i))^2))^2;
        
        n(i,1) = (0.294*n1(i,1))/(Strakes(1,4,i)^2);
        
        q(i,1) = 0.6*pBl(i,1)*bB(i,1)*(1-((0.1*bB(i,1)*k2_plate)/Strakes(1,4,i)));
        
        q1(i,1) = 0.353*sqrt((ReH^3)/n(i,1));

        q2(i,1) = 4.9*q1(i,1);

        if q(i,1) <= q1(i,1)
            Sps0(i,1) = nthroot(q(i,1)/n(i,1),3);
        elseif q(i,1) > q1(i,1) && q(i,1) < q2(i,1)
            Sps0(i,1) = 0.455*((q(i,1)/ReH)+sqrt(((q(i,1)/ReH)^2))+((1.32*ReH)/n(i,1)));
        elseif q(i,1) >= q2(i,1)
            Sps0(i,1) = 1.73*sqrt(Reh/n(i,1));
        end
        
        Sps(i,1) = Sps0(i,1) + Delta_s;                 %[mm]
        
        if Sps(i,1) > Sps1(i,1)
            Sps(i,1) = Sps(i,1);
        else
            Sps(i,1) = Sps1(i,1);
        end   
    end
end


%Check values for Russian Register ice rules%

%Check value of shell plating thickness%
for i=1:Csec_size/2
    if Strakes(1,1,i) == 9 ||Strakes(1,1,i) == 8 || Strakes(1,1,i) == 2 || Strakes(1,1,i) == 1
        Ssp_check(i,1) = (Ssp(i,1)-(Strakes(1,3,i)*10))./(Ssp(i,1)+(Strakes(1,3,i)*10));
    end
end

%Check values shell of intertia moment of stiffeners%
for i=1:Csec_size/2
    if Strakes(1,1,i) == 9 ||Strakes(1,1,i) == 8 || Strakes(1,1,i) == 2 || Strakes(1,1,i) == 1
        I_check(i,1) = (I(i,1)-Strakes(1,5,i))./(I(i,1)+Strakes(1,5,i));
    end
end

%Check values of face plate breadth of a longitudinal (side and bottom)%
for i=1:Csec_size/2
    if Strakes(1,1,i) == 9 ||Strakes(1,1,i) == 8 || Strakes(1,1,i) == 2 || Strakes(1,1,i) == 1
        cl_check(i,1) = (cl(i,1)-Strakes(1,18,i))./(cl(i,1)+Strakes(1,18,i));
    end
end

%Check values of web thickness of a longitudinal (side and bottom)%
for i=1:Csec_size/2
    if Strakes(1,1,i) == 9 ||Strakes(1,1,i) == 8 || Strakes(1,1,i) == 2 || Strakes(1,1,i) == 1
        sl_check(i,1) = (sl(i,1)-(Strakes(1,13,i)*10))./(sl(i,1)+(Strakes(1,13,i)*10));
    end
end

%Check values of ultimate section modulus of a longitudinal (side and bottom)%
for i=1:Csec_size/2
    if Strakes(1,1,i) == 9 ||Strakes(1,1,i) == 8 || Strakes(1,1,i) == 2 || Strakes(1,1,i) == 1
        Wl_check(i,1) = (Wl(i,1)-Wa(i,1))./(Wl(i,1)+Wa(i,1));
    end
end

%Check values of web area of a longitudinal (side and bottom)%
for i=1:Csec_size/2
    if Strakes(1,1,i) == 9 ||Strakes(1,1,i) == 8 || Strakes(1,1,i) == 2 || Strakes(1,1,i) == 1
        Al_check(i,1) = (Al(i,1)-Aa(i,1))./(Al(i,1)+Aa(i,1));
    end
end

%Check values of plate thickness of bottom strigers and centre girder%
for i=1:Csec_size/2
    if Strakes(1,1,i) == 4 ||Strakes(1,1,i) == 5 || Strakes(1,1,i) == 7 || Strakes(1,1,i) == 13
        Sps_check(i,1) = (Sps(i,1)-(Strakes(1,3,i)*10))./(Sps(i,1)+(Strakes(1,3,i)*10));
    end
end

Ssp_check(Ssp==0)=[];
Ssp(Ssp==0)=[];

Al_check(Al==0)=[];
Al(Al==0)=[];

Wl_check(Wl==0)=[];
Wl(Wl==0)=[];

sl_check(sl==0)=[];
sl(sl==0)=[];

cl_check(cl==0)=[];
cl(cl==0)=[];

I_check(I==0)=[];
I(I==0)=[];

Sps_check(Sps==0)=[];
Sps(Sps==0)=[];



check_RR = [max(Sps_check) max(Al_check) max(Wl_check) max(sl_check) max(cl_check) max(I_check) max(Sps_check)];
test = 1;

